﻿using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;

namespace ObjectConfig {
    public class Startup {
        readonly IConfigurationRoot Configuration;

        public Startup(IHostingEnvironment env) {
            // Load configuration from JSON file
            var builder = new ConfigurationBuilder();
            builder.SetBasePath(env.ContentRootPath);
            builder.AddJsonFile("config.json");
            this.Configuration = builder.Build();
        }

        public void ConfigureServices(IServiceCollection services) {
            // Options service
            services.AddOptions();
            services.Configure<MyOptions>(this.Configuration);

            // MVC service
            services.AddMvc();
        }

        public void Configure(IApplicationBuilder app) {
            // Show detailed errors
            app.UseDeveloperExceptionPage();

            // Enable basic MVC
            app.UseMvcWithDefaultRoute();
        }
    }
}
