﻿using System;
using Microsoft.Extensions.Configuration;

namespace UserSecrets {
    public class Program {
        public static void Main(string[] args) {
            // Build configuration
            var builder = new ConfigurationBuilder();
            /* In real app, here are regular configuration sources*/

            // Add user secrets to configuration sources
            builder.SetBasePath(System.IO.Directory.GetCurrentDirectory());
            builder.AddUserSecrets();

            // Read configuration from sources
            var config = builder.Build();

            // Print the secret value
            var secretValue = config["MySecret"];
            Console.WriteLine($"MySecret = '{secretValue}'");

            /*
             The values are physically stored in user profile:
             Windows:   %APPDATA%\microsoft\UserSecrets\<userSecretsId>\secrets.json
             Linux:     ~/.microsoft/usersecrets/<userSecretsId>/secrets.json
             Mac:       ~/.microsoft/usersecrets/<userSecretsId>/secrets.json
             */
        }
    }
}
